function out=drawWorms(im,pts1,pts2,L,W)
%cost=scoreBodyPts(im,pts)


out = im;

len = L;
wid = W;
G = 1/115*[2 4 5 4 2;4 9 12 9 4;5 12 15 12 5;4 9 12 9 4;2 4 5 4 2];

%Buffer everything
pts1 = pts1 + len/2;
pts2 = pts2 + len/2;

%Recreate the bounding box
xx1 = pts1(1:2:end,:);
yy1 = pts1(2:2:end,:);
xx2 = pts2(1:2:end,:);
yy2 = pts2(2:2:end,:);
x1 = floor(min([min(xx1(:)) min(xx2(:))]))-len/2;
x2 = ceil(max([max(xx1(:)) max(xx2(:))]))+len/2;
y1 = floor(min([min(yy1(:)) min(yy2(:))]))-len/2;
y2 = ceil(max([max(yy1(:)) max(yy2(:))]))+len/2;
siz = [(y2-y1+1) (x2-x1+1)];
pts1(1:2:end,:) = pts1(1:2:end,:) - x1 + 1;
pts1(2:2:end,:) = pts1(2:2:end,:) - y1 + 1;
pts2(1:2:end,:) = pts2(1:2:end,:) - x1 + 1;
pts2(2:2:end,:) = pts2(2:2:end,:) - y1 + 1;


%We know we're always dealing with rectangles
%Quantize our rectangles to 12 orientations and handle each separately
numTheta = 24;
thetas = [0:numTheta-1]'/numTheta*2*pi + pi/2;
ru = cos(thetas);
rv = -sin(thetas);
phis = (thetas-pi/2)*180/pi;

[d,numSegs1] = size(pts1);
numSegTypes1 = d/4;
numHalf1 = ceil(numSegTypes1/2);
%assert(numSegTypes == round(numSegTypes));
pts1 = permute(reshape(pts1,[2 2 numSegTypes1 numSegs1]),[3 1 2 4]);
segcen1 = permute(.5*pts1(:,:,1,:) + .5*pts1(:,:,2,:),[1 4 2 3]);
%tmp = squeeze(pts(:,:,2,:) - pts(:,:,1,:));
tmp = permute(pts1(:,:,2,:) - pts1(:,:,1,:),[1 2 4 3]);
len = squeeze(sqrt(sum(tmp.^2,2))) + eps;
u = squeeze(tmp(:,1,:))./len;
v = squeeze(tmp(:,2,:))./len;
segcen1 = round(reshape(segcen1,size(segcen1,1)*size(segcen1,2),2));
%len = len(:)/2;
u = u(:);
v = v(:);
%w = len/3;


[dummy,I1] = max(abs([ru rv]*[u v]'),[],1);
%[dummy,I] = max([ru rv]*[u v]',[],1);

siz = siz(1:2);
yOut1 = zeros(siz);

%Represent segments with respect to the center of the image (so they are easier to rotate)
%imcen = (siz(1:2) - 1)/2;
%segs.x = segs.x - imcen(2);
%segs.y = segs.y - imcen(1);

%segs.len(:) = 0;
%segs.w(:) = 0;

%Pre-render our rectangles
len = L;
wid = W;
mask = zeros([len 2*wid numTheta]);
h_mask = zeros([len 2*wid numTheta]);
template = [zeros(len,wid/2) ones(len,wid) zeros(len,wid/2)];
h_template = [zeros(len,wid/2) ones(len,wid) zeros(len,wid/2)];
h_template(1:wid/2,wid/2+1) = 0;
h_template(1:wid/2,3*wid/2) = 0;
h_template(1,wid/2+1:wid/2+floor(wid/3)) = 0;
h_template(1,3*wid/2-floor(wid/3)+1:3*wid/2) = 0;
for i = len/2+1:len,
    h_template(i,:) = h_template(len-i+1,:);
end

for i = 1:numTheta,
    mask(:,:,i) = imrotate(template,(thetas(i) - pi/2)*180/pi,'crop');
    h_mask(:,:,i) = imrotate(h_template,(thetas(i) - pi/2)*180/pi,'crop');
end

h_mask = uint8(h_mask);
mask = uint8(mask);
%yOut1 = uint8(yOut1);
offs = -(len/2-1):len/2;

cnt1 = 1;
yOut1 = repmat(uint8(0),siz);
for i = 1:numSegTypes1
    if i == 1,
        yOut1(segcen1(cnt1,2)+offs,segcen1(cnt1,1)+offs) = yOut1(segcen1(cnt1,2)+offs,segcen1(cnt1,1)+offs) + h_mask(:,:,I1(cnt1));
    else
        yOut1(segcen1(cnt1,2)+offs,segcen1(cnt1,1)+offs) = yOut1(segcen1(cnt1,2)+offs,segcen1(cnt1,1)+offs) + mask(:,:,I1(cnt1));
    end
    cnt1 = cnt1 + 1;
end

yOut1 = bwmorph(yOut1,'close',1);
yOut1 = filter2(G,yOut1);
for i = 1:size(yOut1,1),
    for j = 1:size(yOut1,2),
        if yOut1(i,j) > 0.5,
            yOut1(i,j) = 1;
        else
            yOut1(i,j) = 0;
        end
    end
end

out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,1) = out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,1).*(1 - uint8(yOut1)) + 255*uint8(yOut1);
out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,2) = out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,2).*(1 - uint8(yOut1));
out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,3) = out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,3).*(1 - uint8(yOut1));

[d,numSegs2] = size(pts2);
numSegTypes2 = d/4;
numHalf2 = ceil(numSegTypes2/2);
%assert(numSegTypes == round(numSegTypes));
pts2 = permute(reshape(pts2,[2 2 numSegTypes2 numSegs2]),[3 1 2 4]);
segcen2 = permute(.5*pts2(:,:,1,:) + .5*pts2(:,:,2,:),[1 4 2 3]);
%tmp = squeeze(pts(:,:,2,:) - pts(:,:,1,:));
tmp = permute(pts2(:,:,2,:) - pts2(:,:,1,:),[1 2 4 3]);
len = squeeze(sqrt(sum(tmp.^2,2))) + eps;
u = squeeze(tmp(:,1,:))./len;
v = squeeze(tmp(:,2,:))./len;
segcen2 = round(reshape(segcen2,size(segcen2,1)*size(segcen2,2),2));
%len = len(:)/2;
u = u(:);
v = v(:);
%w = len/3;

[dummy,I2] = max(abs([ru rv]*[u v]'),[],1);
%[dummy,I] = max([ru rv]*[u v]',[],1);

yOut2 = zeros(siz);
%yOut2 = uint8(yOut2);

len = L;
wid = W;

cnt2 = 1;
yOut2 = repmat(uint8(0),siz);
for j = 1:numSegTypes2
    if j == 1,
        yOut2(segcen2(cnt2,2)+offs,segcen2(cnt2,1)+offs) = yOut2(segcen2(cnt2,2)+offs,segcen2(cnt2,1)+offs) + h_mask(:,:,I2(cnt2));
    else
        yOut2(segcen2(cnt2,2)+offs,segcen2(cnt2,1)+offs) = yOut2(segcen2(cnt2,2)+offs,segcen2(cnt2,1)+offs) + mask(:,:,I2(cnt2));
    end
    cnt2 = cnt2 + 1;
end

yOut2 = bwmorph(yOut2,'close',1);
yOut2 = filter2(G,yOut2);
for i = 1:size(yOut2,1),
    for j = 1:size(yOut2,2),
        if yOut2(i,j) > 0.5,
            yOut2(i,j) = 1;
        else
            yOut2(i,j) = 0;
        end
    end
end

out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,1) = out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,1).*(1 - uint8(yOut2));
out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,2) = out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,2).*(1 - uint8(yOut2)) + 255*uint8(yOut2);
out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,3) = out(y1-len/2:y2-len/2,x1-len/2:x2-len/2,3).*(1 - uint8(yOut2));
