function cost=scoreAllPts(im,pts1,pts2,L,W)
%cost=scoreBodyPts(im,pts)

%len = 8;
%wid = 4;
len = L;
wid = W;

%Buffer everything
im = padarray(im,[len/2 len/2],'both');
pts1 = pts1 + len/2;
pts2 = pts2 + len/2;


[d,numSegs1] = size(pts1);
numSegTypes1 = d/4;
[d,numSegs2] = size(pts2);
numSegTypes2 = d/4;
%Recreate the bounding box
xx1 = pts1(1:2:end,:);
yy1 = pts1(2:2:end,:);
xx2 = pts2(1:2:end,:);
yy2 = pts2(2:2:end,:);
x1 = floor(min(min(xx1(:)),min(xx2(:))))-len/2;
x2 = ceil(max(max(xx1(:)),max(xx2(:))))+len/2;
y1 = floor(min(min(yy1(:)),min(yy2(:))))-len/2;
y2 = ceil(max(max(yy1(:)),max(yy2(:))))+len/2;
siz = [(y2-y1+1) (x2-x1+1)];
pts1(1:2:end,:) = pts1(1:2:end,:) - x1 + 1;
pts2(1:2:end,:) = pts2(1:2:end,:) - x1 + 1;
pts1(2:2:end,:) = pts1(2:2:end,:) - y1 + 1;
pts2(2:2:end,:) = pts2(2:2:end,:) - y1 + 1;
im = im(y1:y2,x1:x2);


%We know we're always dealing with rectangles
%Quantize our rectangles to 12 orientations and handle each separately
numTheta = 24;
thetas = [0:numTheta-1]'/numTheta*2*pi + pi/2;
ru = cos(thetas);
rv = -sin(thetas);
phis = (thetas-pi/2)*180/pi;

%The first worm
%assert(numSegTypes == round(numSegTypes));
pts1 = permute(reshape(pts1,[2 2 numSegTypes1 numSegs1]),[3 1 2 4]);
segcen1 = permute(.5*pts1(:,:,1,:) + .5*pts1(:,:,2,:),[1 4 2 3]);
%tmp = squeeze(pts(:,:,2,:) - pts(:,:,1,:));
tmp = permute(pts1(:,:,2,:) - pts1(:,:,1,:),[1 2 4 3]);
len = squeeze(sqrt(sum(tmp.^2,2))) + eps;
u = squeeze(tmp(:,1,:))./len;
v = squeeze(tmp(:,2,:))./len;
segcen1 = round(reshape(segcen1,size(segcen1,1)*size(segcen1,2),2));
%len = len(:)/2;
u = u(:);
v = v(:);
%w = len/3;

[dummy,I1] = max(abs([ru rv]*[u v]'),[],1);
%[dummy,I] = max([ru rv]*[u v]',[],1);

%The second worm
%assert(numSegTypes == round(numSegTypes));
pts2 = permute(reshape(pts2,[2 2 numSegTypes2 numSegs2]),[3 1 2 4]);
segcen2 = permute(.5*pts2(:,:,1,:) + .5*pts2(:,:,2,:),[1 4 2 3]);
%tmp = squeeze(pts(:,:,2,:) - pts(:,:,1,:));
tmp = permute(pts2(:,:,2,:) - pts2(:,:,1,:),[1 2 4 3]);
len = squeeze(sqrt(sum(tmp.^2,2))) + eps;
u = squeeze(tmp(:,1,:))./len;
v = squeeze(tmp(:,2,:))./len;
segcen2 = round(reshape(segcen2,size(segcen2,1)*size(segcen2,2),2));
%len = len(:)/2;
u = u(:);
v = v(:);
%w = len/3;

[dummy,I2] = max(abs([ru rv]*[u v]'),[],1);
%[dummy,I] = max([ru rv]*[u v]',[],1);

siz = siz(1:2);
temp = zeros(siz);
yOut = zeros(siz);

%Represent segments with respect to the center of the image (so they are easier to rotate)
%imcen = (siz(1:2) - 1)/2;
%segs.x = segs.x - imcen(2);
%segs.y = segs.y - imcen(1);

%segs.len(:) = 0;
%segs.w(:) = 0;

%Pre-render our rectangles
%len = 8;
%wid = 4;
len = L;
wid = W;

mask = zeros([len 2*wid numTheta]);
template = [zeros(len,wid/2) ones(len,wid) zeros(len,wid/2)];
for i = 1:numTheta,
    mask(:,:,i) = imrotate(template,(thetas(i) - pi/2)*180/pi,'crop');
end

mask = uint8(mask);
offs = -(len/2-1):len/2;
cost  = zeros(numSegs1,numSegs2);

cnt1 = 1;
for i = 1:numSegs1,
   yOut1 = repmat(uint8(0),siz);
   for j = 1:numSegTypes1
       yOut1(segcen1(cnt1,2)+offs,segcen1(cnt1,1)+offs) = yOut1(segcen1(cnt1,2)+offs,segcen1(cnt1,1)+offs) + mask(:,:,I1(cnt1));
       cnt1 = cnt1 + 1;
   end
   
   cnt2 = 1;
   for k = 1:numSegs2,
       yOut2 = repmat(uint8(0),siz);
       for l = 1:numSegTypes2
           yOut2(segcen2(cnt2,2)+offs,segcen2(cnt2,1)+offs) = yOut2(segcen2(cnt2,2)+offs,segcen2(cnt2,1)+offs) + mask(:,:,I2(cnt2));
           cnt2 = cnt2 + 1;
       end
       %Calculate the percenrage of the worm body area covered by the model
       %temp = (yOut1 > 0 | yOut2 > 0) & im1 > 0;
       %cost(i,k) = sum(temp(:) > 0)/sum(im(:) > 0);
       temp1 = yOut1 > 0 & yOut2 > 0;
       temp2 = yOut1 == 0 & yOut2 == 0 & im > 0;
       cost(i,k) = sum(temp1(:) > 0) + sum(temp2(:) > 0);
   end
end
