load result_1
%cmuTrack.m
global S;
S.firstFrame = 0;
S.lastFrame = 36;
S.formatS = 'jpeg';
S.imageS = '0000';
S.imageLocS = 'D:\modeling\images';
%S.imageLocS = 'D:\modeling\new_videos\New Folder';
S.scaleIm = 1/1.5;
saveS = 'D:\modeling\Results\result.mat';

MAX_NUM = 1000;
THRESH = .1;
dbclear if warning;

%Define the 1st chain worm model
numTypes1  = 7;
genmodel1.pre = 1:numTypes1;
genmodel1.post = fliplr(genmodel1.pre);
genmodel1.root = 1;
genmodel1.dag = zeros(numTypes1);
genmodel1.parents = cell(numTypes1,1);
for i = 1:numTypes1 - 1,
genmodel1.dag(i,i+1) = 1;
genmodel1.parents{i+1} = i;
end

%Define the 2nd chain worm model
numTypes2  = 7;
genmodel2.pre = 1:numTypes2;
genmodel2.post = fliplr(genmodel2.pre);
genmodel2.root = 1;
genmodel2.dag = zeros(numTypes2);
genmodel2.parents = cell(numTypes2,1);
for i = 1:numTypes2 - 1,
genmodel2.dag(i,i+1) = 1;
genmodel2.parents{i+1} = i;
end

frames = 1:(S.lastFrame - S.firstFrame + 1);
%frames = 1:20; %Debug; just do first 20
[ptsAll1,costsAll1] = deal(cell(length(frames),1));
[ptsAll2,costsAll2] = deal(cell(length(frames),1));
%costsTemp = costsAll;
finalSegs1 = [];
finalSegs2 = [];
%len = 16;
%wid = 8;
len = 12;
wid = 6;

MAX_NUM = 1000;
P_MD = exp(-4); %Probality of a missed detection (not finding a link)

%******MAIN MATCHING PROCEDURE*******
for i = 1:length(frames),
    i

  frames(i) = frames(i) + 186;
  %im = imclose(imresize(rgb2gray(myImRead(S,frames(i))),S.scaleIm) < 150,strel('disk',3));
  im = bwmorph(imresize(rgb2gray(myImRead(S,frames(i))),S.scaleIm) < 150,'close');
  im = backrem(im);
  im(45:75,230:260) = 0;
  
  %Find a whole bunch of candidate worm links
  res1 = findCandidateLinks(im,len,wid,MAX_NUM,P_MD);
  res2 = findCandidateLinks(im,len,wid,MAX_NUM,P_MD);
  
  %This function returns a bunch of worm bodies, sampled from the posterior
  [ptsAll1{i},costsAll1{i},segs1] = sampleWormBodyPts(res1,genmodel1,1000);
  [ptsAll2{i},costsAll2{i},segs2] = sampleWormBodyPts(res2,genmodel2,1000);

  %Re-evaluate the cost of the samples with global cost measure
  costsAll1{i} = scoreBodyPts(im,ptsAll1{i},len,wid);% + scoreBrightness(im,ori_im,ptsAll1{i});;
  costsAll2{i} = scoreBodyPts(im,ptsAll2{i},len,wid);% + scoreBrightness(im,ori_im,ptsAll2{i});;

  segs1.fr = repmat(frames(i),size(segs1.x));
  segs2.fr = repmat(frames(i),size(segs2.x));
  finalSegs1 = appendSegs(finalSegs1,segs1);
  finalSegs2 = appendSegs(finalSegs2,segs2);
  %Show the single best worm body
  %showsegIm(im,segs);
  %drawnow;
end
%Save our results
%save(saveS,'ptsAll1','ptsAll2','costsAll1','costsAll2','finalSegs1','finalSegs2','-append');


%To speed stuff up, only keep the best 1/3 of the samples from each frame
NUM1 = size(ptsAll1{1},2)/1;
for i = 1:length(frames),
    [dummy,I] = sort(costsAll1{i});
    I = I(1:NUM1);
    ptsAll1{i} = ptsAll1{i}(:,I);
    costsAll1{i} = costsAll1{i}(I);
end

NUM2 = size(ptsAll2{1},2)/1;
for i = 1:length(frames),
    [dummy,I] = sort(costsAll2{i});
    I = I(1:NUM2);
    ptsAll2{i} = ptsAll2{i}(:,I);
    costsAll2{i} = costsAll2{i}(I);
end


num = 10;
%Now do dynamic programming to find a sequence of worm bodies
%that moves smoothly over time
ptr1 = repmat(uint16(0),NUM1,length(frames));
cont_W = 5e-2;
numFr = length(frames);

%Find the best combination

%Initial conditions (if start from the middle of the video)
costsAll1{1} = zeros(NUM1,1);
costsAll2{1} = zeros(NUM2,1);
ptsAll1{1} = repmat(pts1(:,187),1,NUM1);
ptsAll2{1} = repmat(pts2(:,187),1,NUM2);

%The first worm
i = 1;
count = 2;
for i = 2:numFr,
    i
    [val,I] = min(sq_distance_ft(ptsAll1{i-1},ptsAll1{i}).*cont_W + repmat(costsAll1{i-1},1,NUM1));
    %if count == 50,
    %    ptr1(:,i) = I';
    %    count = 1;
    %else
        costsAll1{i} = costsAll1{i} + val';
        ptr1(:,i) = I';
        count = count + 1;
    %end
end



%Back track
Iall1 = zeros(numFr,num);
[cost1,index] = sort(costsAll1{numFr},'ascend');
Iall1(numFr,:) = index(1:num)';
for i = 1:num,
    for j = numFr-1:-1:1,
        Iall1(j,i) = ptr1(Iall1(j+1,i),j+1);
    end
end

costsAll = zeros(1,num);
for i = 1:num,
    i
    [val,I] = min(scoreAllPts(im,ptsAll1{1}(:,Iall1(1,i)),ptsAll2{1},len,wid));
    Iall2(1,i) = I;
    costsAll(i) = costsAll(i) + val;
    for j = 2:numFr,
        [val,I] = min(sq_distance_ft(ptsAll2{j-1}(:,Iall2(j-1,i)),ptsAll2{j}).*cont_W + 2*scoreAllPts(im,ptsAll1{j}(:,Iall1(j,i)),ptsAll2{j},len,wid));
        Iall2(j,i) = I;
        costsAll(i) = costsAll(i) + val + sq_distance_ft(ptsAll1{j-1}(:,Iall1(j-1,i)),ptsAll1{j}(:,Iall1(j,i))).*cont_W;
    end
end

[dummy, index] = min(costsAll);
I1 = Iall1(:,index);
I2 = Iall2(:,index);

pts1 = [];
pts2 = [];
for i = 1:numFr,
    pts1 = [pts1 ptsAll1{i}(:,I1(i))];
    pts2 = [pts2 ptsAll2{i}(:,I2(i))];
end

%Now, we have the best worm track
%To make it pretty, we'll smooth it over time by averaging neighboring
%frames

outSegs1 = [];
for i = 1:numFr,
    ptCurr = pts1(:,i);
    if i > 1,
        ptPrev = pts1(:,i-1);
    else
        ptPrev = ptCurr;
    end
    if i < numFr,
        ptNext = pts1(:,i+1);
    else
        ptNext = ptCurr;
    end
    %segs = pt2seg(ptPrev/3 + ptNext/3 + ptCurr/3);
    %segs.fr = repmat(i,size(segs.x));
    %segs.type = [1:numTypes1]';
    %outSegs1 = appendSegs(outSegs1,segs);
    segs = ptPrev/3 + ptNext/3 + ptCurr/3;
    outSegs1 = [outSegs1 segs];
end



outSegs2 = [];
for i = 1:numFr,
    ptCurr = pts2(:,i);
    if i > 1,
        ptPrev = pts2(:,i-1);
    else
        ptPrev = ptCurr;
    end
    if i < numFr,
        ptNext = pts2(:,i+1);
    else
        ptNext = ptCurr;
    end
    %segs = pt2seg(ptPrev/3 + ptNext/3 + ptCurr/3);
    %segs.fr = repmat(i,size(segs.x));
    %segs.type = [1:numTypes2]';
    %outSegs2 = appendSegs(outSegs2,segs);
    segs = ptPrev/3 + ptNext/3 + ptCurr/3;
    outSegs2 = [outSegs2 segs];
end

%***DONE WITH ALGORITHM****
%The remaining stuff just makes fancy movies

%Visualize the sampled worm bodies
%clear SM;
%im = imresize(myImRead(S,1),S.scaleIm);
%for i = 1:numFr,
%    ptCurr = ptsAll{i}(:,Iall1(i));
%    %Find all the samples close to the best one
%    inds = find(sum((repmat(ptCurr,1,NUM) - ptsAll{i}).^2) < 2e3);
%    %Draw them all
%    SM(i) = im2frame(showWormBodyPts(size(im),ptsAll{i}(:,inds)));
%    drawnow;
%end

%Low-pass filter the images over time
%tmp = SM;
%for i = 2:length(SM)-1
%    SM(i).cdata = imlincomb(1/3,tmp(i-1).cdata,1/3,tmp(i).cdata,1/3,tmp(i+1).cdata);
%end

iptsetpref('ImshowBorder','tight');
for i = 1:numFr,
    im = imresize(myImRead(S,i+186),S.scaleIm);   
    %im = imresize(myImRead(S,i),S.scaleIm);
    %im = [im im];
    %outSegs = [subSegs(outSegs1,outSegs1.fr == i )
    %           subSegs(outSegs2,outSegs2.fr == i )];
    %showsegImAll(im,outSegs);
    out = drawWorms(im,outSegs1(:,i),outSegs2(:,i),len,wid);
    im = [im out];
    imshow(im);
    M(i) = getframe;
end
%Two movies are now M (the best track) and SM (the samples)
